﻿#!/bin/sh


FONT_DIR=/mmc/mmca1/.fonts
AUTO_FONT="$FONT_DIR/auto_`basename ${0%%.*}`"
AUTO_RUN="/mmc/mmca1/.system/font.sh"
TAKE="Поместите сюда файлы шрифтов (*.ttf) и повторите попытку."
stable_ttf=/mnt/msc_int0/font.ttf

re_init_phone()	
{	
	cp -f $SELECTED_FONT $stable_ttf
	mount -o bind $stable_ttf /usr/language/fonts/AMCSL.TTF
	mount -o bind $stable_ttf /usr/language/fonts/NUMBER.TTF
	return 0
}

verify_exp()
{
	case ${1##*.} in
		[Tt][Tt][Ff] ) :;;
		*            ) showNotify "Ошибка!" "Выбранный Вами файл: "$1", не является файлом шрифтов!" 1 5
		      	       return 1
		;;
	esac
	return 0
}

display_list()
{
	if [ ! -d $FONT_DIR ]; then
		mkdir $FONT_DIR
		if [ $? -eq 0 ]; then
			showNotify "Создание каталога" "Каталог: $FONT_DIR/ успешно создан. $TAKE" 1 10
			return 1
		else
			showNotify "Создание каталога" "Ошибка! Немогу создать каталог $FONT_DIR" 1 4
			return 1
		fi
	fi
	FONT_LIST=$(ls "$FONT_DIR")
	if [ -z "$FONT_LIST" ]; then
		showNotify "Предупреждение" "Шрифтов в $FONT_DIR/ не найденно! $TAKE" 1 10
		return 1
	fi
		unset FONT_LIST
 	for FONT in "$FONT_DIR/"*.[Tt][Tt][Ff]; do
		FONT_LIST="$FONT_LIST $(basename $FONT)"
	done

	showRadio "Изм. шрифтов" "Выберите шрифт" $FONT_LIST
	SELVALUE=$?
	for SEL in "$FONT_DIR/"*.[Tt][Tt][Ff]; do
		let i=$i+1
		if [ $i -eq $SELVALUE ]; then
			SELECTED_FONT=$SEL
			break
		fi
	done
	return 0
}

add_autorun()
{
	if [ -e $AUTO_RUN ]; then
		grep -q "$0 -auto" $AUTO_RUN
		if [ $? -ne 0 ]; then
			echo "#Auto Change font" >> $AUTO_RUN
			echo "$0 -auto" >> $AUTO_RUN
			if [$? -ne 0 ]; then	
				showNotify "Ошибка!!!" "Невозможно добавить параметр автосмены !!!" 1 5
				return 1
			fi
		fi
	fi
	return 0
}

if [ "$1" = "-auto" ]; then
	if [ -e "$AUTO_FONT" ] && [ -e "`busybox head -n 1 $AUTO_FONT`" ]; then
		grep -q 'AMCSL.TTF' /etc/mtab
		if [ $? -eq 0 ]; then
			i="`busybox head -n 1 $AUTO_FONT`"	
			showNotify "Изм. шрифтов" "Установленно: \"${i##*/}"\" 1 5
			unset i
			exit 0
		fi
		SELECTED_FONT="`busybox head -n 1 $AUTO_FONT`"
		verify_exp $SELECTED_FONT
		if [ $? -ne 0 ]; then
			showNotify "Ошибка!!!" "Указаный файл: "$SELECTED_FONT" в "$AUTO_FONT" не является файлом шрифтов." 1 5
			echo "" > "$AUTO_FONT"
			exit 1
		else
			showNotify "Изм. шрифтов" "Устанавливаю: "$SELECTED_FONT" в качестве файла шрифтов ..." 1 5
			re_init_phone
		fi
		exit $?
	else
		showMsg "Изм. шрифтов" "Файл: $AUTO_FONT или указанный в нём шрифт ненайден или несуществует! Установить другой?" 1
		if [ $? -ne 0 ]; then
			/bin/sh $0 &
			exit 0
		else
			exit 1
		fi 
	fi
fi

display_list
if [ -z $SELECTED_FONT ]; then
	exit 1
fi

verify_exp $SELECTED_FONT
if [ $? -ne 0 ]; then
	/bin/sh $0 &
	exit 1
else 	
	add_autorun
	echo $SELECTED_FONT > $AUTO_FONT
	showMsg "Изм. шрифтов" "Выбран шрифт: \"${SELECTED_FONT##*/}\". Для завершения операции требуется перезагрузка, сделать сейчас?" 1
	if [ $? -ne 0 ]; then
		showNotify "Изм. шрифтов" "Перегружаю..." 1 1
		/sbin/reboot
	fi
fi

exit $?